<?php

namespace App\Tasks\MassInsert;

use App\Models\Transaction;
use Carbon\Carbon;
use Illuminate\Support\Facades\DB;

class MassInsert4Task
{

    /**
     * insert unit with transaction
     *
     *    1000 - Database\Seeders\TransactionSeeder ......   391.11 ms DONE
     *   10000 - Database\Seeders\TransactionSeeder .....  3,741.94 ms DONE
     *  100000 - Database\Seeders\TransactionSeeder ....  38,605.27 ms DONE
     * 1000000 -
     *
     * 1. insert into transactions (id, value, date) values (1, 10, '2023-04-01');
     * 2. insert into transactions (id, value, date) values (2, 20, '2023-04-02');
     * .... 100.000
     *
     *  - reconstroi os indices, verifica chave, view materializada
     */
    public function handle(int $count): void
    {
        DB::beginTransaction();
        try {
            Transaction::factory($count)->create();
            DB::commit();
        } catch (\Exception $exception) {
            DB::rollBack();
        }
    }
}
