<?php

namespace App\Tasks\MassUpdate\Group1;

use App\Models\Transaction;
use Carbon\Carbon;
use Illuminate\Support\Facades\DB;

class MassUpdate1Task
{
    /**
     * Atualiza o campo data e valor, uma transação por vez.
     * Atualizando de forma unitária com where('id', 1), where('id', 2).
     *
     *    1000 ..........  1s DONE
     *   10000 .......... 14s DONE
     *  100000 ....... 2m 36s DONE
     * 1000000 ...... 26m 10s DONE
     */
    public function handle()
    {
        Transaction::query()
            ->select([
                'id',
            ])
            ->where('id', '>', 0)
            ->chunkById(1000, function ($transactions) {
                foreach ($transactions as $transaction) {
                    Transaction::query()
                        ->where('id', '=', $transaction->id)
                        ->update([
                            'date' => Carbon::now(),
                            'value' => 1,
                        ]);
                }
            });

    }
}
